Revit有部分创建元素的命令有一个特点,就是创建命令执行完后会重新调用这个命令,除非使用Esc或者右键取消这个命令。例如创建门,常规交互是这样的:点击门按钮->进入选择状态->选择一面墙->门族被创建->重新进入选择状态。

如果编写的插件也想实现类似的交互效果,其实也很简单,只需要把命令写到一个方法内部,方法最后重新调用本身即可。要注意的是当在选择状态取消命令时会出现OperationCanceledException报错,需要稍微处理一下。

在这里记录一个简单的例子,可以一直重复执行选择元素然后提示元素ID的命令。

代码:

using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using Autodesk.Revit.Attributes;
 
namespace ClassLibrary2
{
 [Transaction(TransactionMode.Manual)]
 class newTest : IExternalCommand
 {
 public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
 {
 ShowElementId(commandData.Application.ActiveUIDocument);
 return Result.Succeeded;
 }
 
 bool ShowElementId(UIDocument uIDocument)
 {
 try
 {
 ElementId elemId = uIDocument.Selection.PickObject(Autodesk.Revit.UI.Selection.ObjectType.Element, "选择一个元素").ElementId;
 TaskDialog.Show("newTest", elemId.ToString());
 ShowElementId(uIDocument);
 }
 catch(Autodesk.Revit.Exceptions.OperationCanceledException ex)
 {
 return false;
 }
 return true;
 
 }
 }
}

 

0

评论0

请先
高清正式版 T/CECS 1069-2022 钢筋桁架楼承板应用技术规程
高清正式版 T/CECS 1069-2022 钢筋桁架楼承板应用技术规程
6分钟前 有人购买 去瞅瞅看

社交账号快速登录

微信扫一扫关注
扫码关注后会自动登录网站